## Description
Blue-green deployment is a technique that reduces downtime and risk by running two identical production environments called Blue and Green.

At any time, only one of the environments is live, with the live environment serving all production traffic. For this example, Blue is currently live and Green is idle.

As you prepare a new version of your software, deployment and the final stage of testing takes place in the environment that is not live: in this example, Green. Once you have deployed and fully tested the software in Green, you switch the router so all incoming requests now go to Green instead of Blue. Green is now live, and Blue is idle.

This technique can eliminate downtime due to app deployment. In addition, blue-green deployment reduces risk: if something unexpected happens with your new version on Green, you can immediately roll back to the last version by switching back to Blue.

![](docs/arch.png)

---------
## requirement
 before use this playbook, firs run  [os_config](https://gitlab.com/majid.darvishfard/ansible_os_config) playbook for install docker and nginx.
 this playbook need some python modules, run `pip install -r ./ansible-bluegreen-docker/requirements.txt` for install 

## attention
 if playbook faild in healthcheck step, run playbook again

